"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var keepalive_1 = require("./keepalive");
var pingPong_1 = require("./pingPong");
var token_1 = require("./token");
var transfer_1 = require("./transfer");
var unsubscribe_1 = require("./unsubscribe");
function applyProtocol(options) {
    var protocolOverhead = [];
    protocolOverhead.push(keepalive_1.applyKeepalive(options.connection));
    protocolOverhead.push(pingPong_1.applyPingPong(options.connection));
    protocolOverhead.push(token_1.applyToken(options.connection, options.tokenEncoder));
    protocolOverhead.push(transfer_1.applyTransfer(options.connection, options.getConnection));
    protocolOverhead.push(unsubscribe_1.applyUnsubscribe(options.connection));
    protocolOverhead.push([options.connection.closeObservable.subscribe(function () {
            protocolOverhead.forEach(function (list) { return list.forEach(function (sub) { return sub.unsubscribe(); }); });
        })]);
}
exports.applyProtocol = applyProtocol;
