"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ONE_SECOND = 1000;
function applyKeepalive(connection) {
    var timeoutId;
    function restartTimer() {
        if (timeoutId) {
            clearTimeout(timeoutId);
        }
        timeoutId = setTimeout(function () {
            connection.close();
        }, 60 * ONE_SECOND);
    }
    var dataSubscription = connection.dataObservable.subscribe(restartTimer);
    var controlSubscription = connection.controlObservable.subscribe(restartTimer);
    return [dataSubscription, controlSubscription];
}
exports.applyKeepalive = applyKeepalive;
