"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Rx_1 = require("rxjs/Rx");
var CLIENT_TOKEN_TYPE = 'client-token';
var ONE_SECOND = 1000;
var MAX_TRIES = 12;
function applyToken(connection, encoder) {
    return Rx_1.Observable.fromPromise(encoder(connection.getId(), connection.getClientAddress()).then(function (token) {
        connection.sendControl(CLIENT_TOKEN_TYPE, token);
        var sendTokenSubscription = Rx_1.Observable.timer(0, 20 * ONE_SECOND).subscribe(function (i) {
            if (i >= MAX_TRIES) {
                connection.close();
                return;
            }
            connection.sendControl(CLIENT_TOKEN_TYPE, token);
        });
        var getTokenSubscription = connection.listenControl(CLIENT_TOKEN_TYPE).subscribe(function (receivedToken) {
            if (receivedToken !== token) {
                connection.close();
            }
            sendTokenSubscription.unsubscribe();
        });
        return [sendTokenSubscription, getTokenSubscription];
    })).flatMap(function (subs) { return subs; });
}
exports.applyToken = applyToken;
