"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function deserializeMessage(message, mapper) {
    var parsed;
    try {
        parsed = JSON.parse(message);
    }
    catch (e) {
        return null;
    }
    if (typeof parsed !== 'object') {
        return null;
    }
    return {
        type: parsed.type,
        payload: typeof mapper === 'function' ? mapper(parsed.payload) : parsed.payload
    };
}
exports.deserializeMessage = deserializeMessage;
function serializeMessage(type, payload) {
    return JSON.stringify(makeMessage(type, payload));
}
exports.serializeMessage = serializeMessage;
/* ----- PRIVATE ----- */
function makeMessage(type, payload) {
    return {
        type: type,
        payload: payload
    };
}
