/// <reference types="node" />
import { request as ConnectionRequest } from 'websocket';
import { Server as HttpServer } from 'http';
import { StockingsConnection, SubscriptionTracker } from './stockingsConnection';
export interface StockingsConnectionRequest extends ConnectionRequest {
}
export interface StockingsServerOptions {
    server: HttpServer;
    privateKey: string;
    publicKey?: string;
    requestFilter?: (req: StockingsConnectionRequest) => boolean;
    algorithm?: string;
    disposeMetaAfter?: number;
}
export declare class StockingsServer implements SubscriptionTracker {
    private _socketServer;
    private _server;
    private _connections;
    private _connectionsBySubscription;
    private _acceptRequest;
    private _encoder;
    private _decoder;
    constructor(options: StockingsServerOptions);
    getConnection(token: string, address: string): Promise<StockingsConnection>;
    sendData<T>(type: string, payload: T, cb?: (err?: any) => void): void;
    registerSubscription(connection: StockingsConnection, type: string): void;
    unregisterSubscription(connection: StockingsConnection, type: string): void;
}
